import React from 'react';
import { AnyAtom, AnyWritableAtom } from './types';
export declare type Actions = {
    init: (id: symbol | null, atom: AnyAtom) => void;
    dispose: (id: symbol) => void;
    write: (atom: AnyWritableAtom, update: unknown) => void;
};
export declare type AtomState<Value = unknown> = {
    promise: Promise<void> | null;
    value: Value;
};
declare type State = Map<AnyAtom, AtomState>;
export declare const ActionsContext: React.Context<Actions>;
export declare const StateContext: React.Context<State>;
export declare const Provider: React.FC;
export {};
